<?php



require_once 'config.php';
require_once GREEN_ZONE_DIR . 'Utils/StringUtils.php';



/**
 * This file will test all the classes it can find
 **/

// get all the names of all the functional classes (exclude test classes)

$all_lines = Array();
$ret_val = '';
exec( 'find ./Classes/ -name "*.php" | grep -v Classes/Tests/', $all_lines, $ret_val );

$class_names = Array();
foreach( $all_lines as $next_filename )
{
  $class_names[] = strword( strword( $next_filename, 3, '/' ), 0, '.' );
}

// get the names of all the classes that we have tests for

$all_lines = Array();
exec( 'find ./Tests/ -name "*.php"', $all_lines, $ret_val );

$test_class_names = Array();
foreach( $all_lines as $next_filename )
{
  require_once $next_filename;
  
  $next_class_name = AdvanceStringTo( strword( strword( $next_filename, 2, '/' ), 0, '.' ), 'Test' );
  if( $next_class_name != 'Classes' )
    $test_class_names[] = $next_class_name;
}

// output the list of untested classes

echo '<H3> The following classes have no associated tests </H3>';
foreach( $class_names as $class )
{
  if( !in_array( $class, $test_class_names ) )
    echo $class . '<br>';
}

// Now iterate through all the actual tests

echo '<H3> Perform all the tests we have </H3>';

foreach( $test_class_names as $next_class )
{
  echo '<b>' . $next_class . '</b><br><br>';
  eval( '$test = new Test' . $next_class . '();' );
  $test->TestIt();
  echo '<br>';
}


?>